searchNodes=[{"doc":"JSONRPC2 is an Elixir library for JSON-RPC 2.0.It includes request and response utility modules, a transport-agnostic server handler, a line-based TCP server and client, which are based on Ranch and shackle, respectively, and a JSON-in-the-body HTTP(S) server and client, based on Plug and hackney, respectively.TCP Example# Define a handler defmodule Handler do use JSONRPC2.Server.Handler def handle_request(&quot;hello&quot;, [name]) do &quot;Hello, \#{name}!&quot; end def handle_request(&quot;hello2&quot;, %{&quot;name&quot; =&gt; name}) do &quot;Hello again, \#{name}!&quot; end def handle_request(&quot;subtract&quot;, [minuend, subtrahend]) do minuend - subtrahend end def handle_request(&quot;notify&quot;, [name]) do IO.puts &quot;You have been notified, \#{name}!&quot; end end # Start the server (this will usually go in your OTP application&#39;s start/2) JSONRPC2.Servers.TCP.start_listener(Handler, 8000) # Define the client defmodule Client do alias JSONRPC2.Clients.TCP def start(host, port) do TCP.start(host, port, __MODULE__) end def hello(name) do TCP.call(__MODULE__, &quot;hello&quot;, [name]) end def hello2(args) do TCP.call(__MODULE__, &quot;hello2&quot;, Map.new(args)) end def subtract(minuend, subtrahend) do TCP.cast(__MODULE__, &quot;subtract&quot;, [minuend, subtrahend]) end def notify(name) do TCP.notify(__MODULE__, &quot;notify&quot;, [name]) end end # Start the client pool (this will also usually go in your OTP application&#39;s start/2) Client.start(&quot;localhost&quot;, 8000) # Make a call with the client to the server IO.inspect Client.hello(&quot;Elixir&quot;) #=&gt; {:ok, &quot;Hello, Elixir!&quot;} # Make a call with the client to the server, using named args IO.inspect Client.hello2(name: &quot;Elixir&quot;) #=&gt; {:ok, &quot;Hello again, Elixir!&quot;} # Make a call with the client to the server asynchronously {:ok, request_id} = Client.subtract(2, 1) IO.puts &quot;non-blocking!&quot; #=&gt; non-blocking! IO.inspect JSONRPC2.Clients.TCP.receive_response(request_id) #=&gt; {:ok, 1} # Notifications Client.notify(&quot;Elixir&quot;) #=&gt; You have been notified, Elixir!HTTP Example# Define a handler defmodule Handler do use JSONRPC2.Server.Handler def handle_request(&quot;hello&quot;, [name]) do &quot;Hello, \#{name}!&quot; end def handle_request(&quot;hello2&quot;, %{&quot;name&quot; =&gt; name}) do &quot;Hello again, \#{name}!&quot; end def handle_request(&quot;notify&quot;, [name]) do IO.puts &quot;You have been notified, \#{name}!&quot; end end # Start the server (this will usually go in your OTP application&#39;s start/2) JSONRPC2.Servers.HTTP.http(Handler) # Define the client defmodule Client do alias JSONRPC2.Clients.HTTP @url &quot;http://localhost:4000/&quot; def hello(name) do HTTP.call(@url, &quot;hello&quot;, [name]) end def hello2(args) do HTTP.call(@url, &quot;hello2&quot;, Map.new(args)) end def notify(name) do HTTP.notify(@url, &quot;notify&quot;, [name]) end end # Make a call with the client to the server IO.inspect Client.hello(&quot;Elixir&quot;) #=&gt; {:ok, &quot;Hello, Elixir!&quot;} # Make a call with the client to the server, using named args IO.inspect Client.hello2(name: &quot;Elixir&quot;) #=&gt; {:ok, &quot;Hello again, Elixir!&quot;} # Notifications Client.notify(&quot;Elixir&quot;) #=&gt; You have been notified, Elixir!SerializersAny module which conforms to the same API as Jason's Jason.encode/1 and Jason.decode/1 can be provided as a serializer to the functions which accept them.","ref":"JSONRPC2.html","title":"JSONRPC2","type":"module"},{"doc":"A JSON-RPC 2.0 request ID.","ref":"JSONRPC2.html#t:id/0","title":"JSONRPC2.id/0","type":"type"},{"doc":"A decoded JSON object.","ref":"JSONRPC2.html#t:json/0","title":"JSONRPC2.json/0","type":"type"},{"doc":"A JSON-RPC 2.0 method.","ref":"JSONRPC2.html#t:method/0","title":"JSONRPC2.method/0","type":"type"},{"doc":"A JSON-RPC 2.0 params value.","ref":"JSONRPC2.html#t:params/0","title":"JSONRPC2.params/0","type":"type"},{"doc":"A client for JSON-RPC 2.0 using an HTTP transport with JSON in the body.","ref":"JSONRPC2.Clients.HTTP.html","title":"JSONRPC2.Clients.HTTP","type":"module"},{"doc":"Make a batch request via url for JSON-RPC 2.0 requests.You can also pass headers, http_method, and hackney_opts to customize the options for hackney.See hackney for more information on the available options.","ref":"JSONRPC2.Clients.HTTP.html#batch/5","title":"JSONRPC2.Clients.HTTP.batch/5","type":"function"},{"doc":"Make a call to url for JSON-RPC 2.0 method with params.You can also pass headers, http_method, hackney_opts to customize the options for hackney, and request_id for a custom JSON-RPC 2.0 request ID.See hackney for more information on the available options.","ref":"JSONRPC2.Clients.HTTP.html#call/7","title":"JSONRPC2.Clients.HTTP.call/7","type":"function"},{"doc":"Notify via url for JSON-RPC 2.0 method with params.You can also pass headers, http_method, and hackney_opts to customize the options for hackney.See hackney for more information on the available options.","ref":"JSONRPC2.Clients.HTTP.html#notify/6","title":"JSONRPC2.Clients.HTTP.notify/6","type":"function"},{"doc":"","ref":"JSONRPC2.Clients.HTTP.html#t:batch_result/0","title":"JSONRPC2.Clients.HTTP.batch_result/0","type":"type"},{"doc":"A client for JSON-RPC 2.0 using a line-based TCP transport.","ref":"JSONRPC2.Clients.TCP.html","title":"JSONRPC2.Clients.TCP","type":"module"},{"doc":"Call the given method with params using the client pool named name with options.You can provide the option string_id: true for compatibility with pathological implementations, to force the request ID to be a string.You can also provide the option timeout: 5_000 to set the timeout to 5000ms, for instance.For backwards compatibility reasons, you may also provide a boolean for the options parameter, which will set string_id to the given boolean.","ref":"JSONRPC2.Clients.TCP.html#call/4","title":"JSONRPC2.Clients.TCP.call/4","type":"function"},{"doc":"Asynchronously call the given method with params using the client pool named name with options.Use receive_response/1 with the request_id to get the response.You can provide the option string_id: true for compatibility with pathological implementations, to force the request ID to be a string.You can also provide the option timeout: 5_000 to set the timeout to 5000ms, for instance.Additionally, you may provide the option pid: self() in order to specify which process should be sent the message which is returned by receive_response/1.For backwards compatibility reasons, you may also provide a boolean for the options parameter, which will set string_id to the given boolean.","ref":"JSONRPC2.Clients.TCP.html#cast/4","title":"JSONRPC2.Clients.TCP.cast/4","type":"function"},{"doc":"Send a notification with the given method and params using the client pool named name.This function returns a request_id, but it should not be used with receive_response/1.","ref":"JSONRPC2.Clients.TCP.html#notify/3","title":"JSONRPC2.Clients.TCP.notify/3","type":"function"},{"doc":"Receive the response for a previous cast/3 which returned a request_id.","ref":"JSONRPC2.Clients.TCP.html#receive_response/1","title":"JSONRPC2.Clients.TCP.receive_response/1","type":"function"},{"doc":"Start a client pool named name, connected to host at port.You can optionally pass client_opts, detailed here, as well as pool_opts, detailed here.In addition to the client_opts above, you can also pass:line_packet - by default, packets consist of a 4 byte header containing an unsigned integer in big-endian byte order specifying the number of bytes in the packet, followed by that number of bytes (equivalent to the erlang inet packet type 4). If set to true, packets will instead be terminated by line-endings, for compatibility with older implementations.","ref":"JSONRPC2.Clients.TCP.html#start/5","title":"JSONRPC2.Clients.TCP.start/5","type":"function"},{"doc":"Stop the client pool with name name.","ref":"JSONRPC2.Clients.TCP.html#stop/1","title":"JSONRPC2.Clients.TCP.stop/1","type":"function"},{"doc":"","ref":"JSONRPC2.Clients.TCP.html#t:call_option/0","title":"JSONRPC2.Clients.TCP.call_option/0","type":"type"},{"doc":"","ref":"JSONRPC2.Clients.TCP.html#t:call_options/0","title":"JSONRPC2.Clients.TCP.call_options/0","type":"type"},{"doc":"","ref":"JSONRPC2.Clients.TCP.html#t:cast_options/0","title":"JSONRPC2.Clients.TCP.cast_options/0","type":"type"},{"doc":"","ref":"JSONRPC2.Clients.TCP.html#t:host/0","title":"JSONRPC2.Clients.TCP.host/0","type":"type"},{"doc":"","ref":"JSONRPC2.Clients.TCP.html#t:request_id/0","title":"JSONRPC2.Clients.TCP.request_id/0","type":"type"},{"doc":"JSON-RPC 2.0 Request object utilites.","ref":"JSONRPC2.Request.html","title":"JSONRPC2.Request","type":"module"},{"doc":"Returns a map representing the JSON-RPC2.0 request object for request.","ref":"JSONRPC2.Request.html#request/1","title":"JSONRPC2.Request.request/1","type":"function"},{"doc":"Returns a serialized request using serializer.See the README for more information on serializers.","ref":"JSONRPC2.Request.html#serialized_request/2","title":"JSONRPC2.Request.serialized_request/2","type":"function"},{"doc":"","ref":"JSONRPC2.Request.html#t:request/0","title":"JSONRPC2.Request.request/0","type":"type"},{"doc":"JSON-RPC 2.0 Response object utilites.","ref":"JSONRPC2.Response.html","title":"JSONRPC2.Response","type":"module"},{"doc":"Deserialize the given response using serializer.","ref":"JSONRPC2.Response.html#deserialize_response/2","title":"JSONRPC2.Response.deserialize_response/2","type":"function"},{"doc":"Returns a tuple containing the information contained in response.","ref":"JSONRPC2.Response.html#id_and_response/1","title":"JSONRPC2.Response.id_and_response/1","type":"function"},{"doc":"","ref":"JSONRPC2.Response.html#t:id_and_response/0","title":"JSONRPC2.Response.id_and_response/0","type":"type"},{"doc":"A transport-agnostic server handler for JSON-RPC 2.0.Exampledefmodule SpecHandler do use JSONRPC2.Server.Handler def handle_request(&quot;subtract&quot;, [x, y]) do x - y end def handle_request(&quot;subtract&quot;, %{&quot;minuend&quot; =&gt; x, &quot;subtrahend&quot; =&gt; y}) do x - y end def handle_request(&quot;update&quot;, _) do :ok end def handle_request(&quot;sum&quot;, numbers) do Enum.sum(numbers) end def handle_request(&quot;get_data&quot;, []) do [&quot;hello&quot;, 5] end end SpecHandler.handle(~s({&quot;jsonrpc&quot;: &quot;2.0&quot;, &quot;method&quot;: &quot;subtract&quot;, &quot;params&quot;: [42, 23], &quot;id&quot;: 1})) #=&gt; ~s({&quot;jsonrpc&quot;: &quot;2.0&quot;, &quot;result&quot;: 19, &quot;id&quot;: 1})","ref":"JSONRPC2.Server.Handler.html","title":"JSONRPC2.Server.Handler","type":"behaviour"},{"doc":"Respond to a request for method with params.You can return any serializable result (which will be ignored for notifications), or you can throw these values to produce error responses::method_not_found, :invalid_params, :internal_error, :server_errorany of the above, in a tuple like {:method_not_found, %{my_error_data: 1}} to return extra data{:jsonrpc2, code, message} or {:jsonrpc2, code, message, data} to return a custom error, with or without extra data.","ref":"JSONRPC2.Server.Handler.html#c:handle_request/2","title":"JSONRPC2.Server.Handler.handle_request/2","type":"callback"},{"doc":"An HTTP server which responds to POSTed JSON-RPC 2.0 in the request body.This server will respond to all requests on the given port. If you wish to mount a JSON-RPC 2.0 handler within a Plug-based web app (such as Phoenix), please see JSONRPC2.Servers.HTTP.Plug.","ref":"JSONRPC2.Servers.HTTP.html","title":"JSONRPC2.Servers.HTTP","type":"module"},{"doc":"Returns a supervisor child spec for the given handler via scheme with cowboy_opts.Allows you to embed a server directly in your app's supervision tree, rather than letting Plug/Cowboy handle it.Please see the docs for Plug.Cowboy for the values which are allowed in cowboy_opts.If the server ref is not set in cowboy_opts, handler.HTTP or handler.HTTPS is the default.","ref":"JSONRPC2.Servers.HTTP.html#child_spec/3","title":"JSONRPC2.Servers.HTTP.child_spec/3","type":"function"},{"doc":"Starts an HTTP server for the given handler with cowboy_opts.Please see the docs for Plug.Cowboy for the values which are allowed in cowboy_opts.If the server ref is not set in cowboy_opts, handler.HTTP is the default.","ref":"JSONRPC2.Servers.HTTP.html#http/2","title":"JSONRPC2.Servers.HTTP.http/2","type":"function"},{"doc":"Starts an HTTPS server for the given handler with cowboy_opts.Please see the docs for Plug.Cowboy for the values which are allowed in cowboy_opts. In addition to the normal cowboy_opts, this function also accepts the same extra SSL-related options as Plug.Cowboy.https/3.If the server ref is not set in cowboy_opts, handler.HTTPS is the default.","ref":"JSONRPC2.Servers.HTTP.html#https/2","title":"JSONRPC2.Servers.HTTP.https/2","type":"function"},{"doc":"Shut down an existing server with given ref.","ref":"JSONRPC2.Servers.HTTP.html#shutdown/1","title":"JSONRPC2.Servers.HTTP.shutdown/1","type":"function"},{"doc":"A plug that responds to POSTed JSON-RPC 2.0 in the request body.If you wish to start a standalone server which will respond to JSON-RPC 2.0 POSTs at any URL, please see JSONRPC2.Servers.HTTP.If you wish to mount a JSON-RPC 2.0 handler in an existing Plug-based web application (such as Phoenix), you can do so by putting this in your router:forward &quot;/jsonrpc&quot;, JSONRPC2.Servers.HTTP.Plug, YourJSONRPC2HandlerModuleThe above code will mount the handler YourJSONRPC2HandlerModule at the path &quot;/jsonrpc&quot;.The Plug.Parsers module for JSON is automatically included in the pipeline, and will use the same serializer as is defined in the :serializer key of the :jsonrpc2 application. You can override the default options (which are used in this example) like so:forward &quot;/jsonrpc&quot;, JSONRPC2.Servers.HTTP.Plug, [ handler: YourJSONRPC2HandlerModule, plug_parsers_opts: [ parsers: [:json], pass: [&quot;*/*&quot;], json_decoder: Application.get_env(:jsonrpc2, :serializer) ] ]","ref":"JSONRPC2.Servers.HTTP.Plug.html","title":"JSONRPC2.Servers.HTTP.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"JSONRPC2.Servers.HTTP.Plug.html#call/2","title":"JSONRPC2.Servers.HTTP.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"JSONRPC2.Servers.HTTP.Plug.html#init/1","title":"JSONRPC2.Servers.HTTP.Plug.init/1","type":"function"},{"doc":"A server for JSON-RPC 2.0 using a line-based TCP transport.","ref":"JSONRPC2.Servers.TCP.html","title":"JSONRPC2.Servers.TCP","type":"module"},{"doc":"Returns a supervisor child spec for the given handler on port with opts.Allows you to embed a server directly in your app's supervision tree, rather than letting Ranch handle it.See start_listener/3 for available options.","ref":"JSONRPC2.Servers.TCP.html#child_spec/3","title":"JSONRPC2.Servers.TCP.child_spec/3","type":"function"},{"doc":"Start a server with the given handler on port with opts.Available options:name - a unique name that can be used to stop the server later. Defaults to the value of handler.num_acceptors - number of acceptor processes to start. Defaults to 100.transport - ranch transport to use. Defaults to :ranch_tcp.transport_opts - ranch transport options. For :ranch_tcp, see here.timeout - disconnect after this amount of milliseconds without a packet from a client. Defaults to 1 hour.line_packet - by default, packets consist of a 4 byte header containing an unsigned integer in big-endian byte order specifying the number of bytes in the packet, followed by that number of bytes (equivalent to the erlang inet packet type 4). If set to true, packets will instead be terminated by line-endings, for compatibility with older implementations.","ref":"JSONRPC2.Servers.TCP.html#start_listener/3","title":"JSONRPC2.Servers.TCP.start_listener/3","type":"function"},{"doc":"Stop the server with name.","ref":"JSONRPC2.Servers.TCP.html#stop/1","title":"JSONRPC2.Servers.TCP.stop/1","type":"function"},{"doc":"JSONRPC2JSON-RPC 2.0 for Elixir.Use the included TCP/TLS server/client, JSON-in-the-body HTTP(S) server/client, or bring your own transport.See the examples directory as well as the JSONRPC2 docs for examples.To install, add jsonrpc2 and jason to your list of dependencies in mix.exs:def deps do [{:jsonrpc2, &quot;~&gt; 2.0&quot;}, {:jason, &quot;~&gt; 1.0&quot;}] end","ref":"readme.html","title":"JSONRPC2","type":"extras"},{"doc":"tl;drThe TCP/TLS server/client default packet format has changed in v2.0, causing backwards incompatibility.If your existing servers/clients are working fine in line_packet mode, there is no need to change to the new packet format.However, if you wish to upgrade existing servers/clients to v2.0 safely, you must now pass the line_packet: true option.Here are some examples of adding the option for both server and client:# Server option should be added to `opts` JSONRPC2.Servers.TCP.start_listener(handler, port, name: name, line_packet: true) JSONRPC2.Servers.TCP.child_spec(handler, port, name: name, line_packet: true) # Client option should be added to `client_opts` JSONRPC2.Clients.TCP.start(host, port, name, line_packet: true)Why?The line-terminated packet format caused the size of the packet to be limited by the size of the socket's receive buffer, causing difficult to diagnose errors when the packet size passed the limit.The only downside of the new approach is a 4-byte overhead due to a new header indicating the size of the rest of the packet. In light of the fact that the smallest possible JSON-RPC 2.0 request is approximately 50 bytes, I have decided to make this format the new default in an attempt to follow the principle of least surprise.What if I want to switch to the new packet format, and uptime is a concern?Here's an example approach:Update to v2.0, add line_packet: true, and deploy.Add a new server listener for each existing one, on a different port, without line_packet: true, and deploy.Update clients to use the new port, remove line_packet: true, and deploy.Remove the original server listener for each one you created, and deploy.","ref":"readme.html#v2-0-upgrade","title":"JSONRPC2 - v2.0 Upgrade","type":"extras"},{"doc":"Uses jason by default, but you can use any serializer (it doesn't even have to be JSON, technically).A serializer for jiffy is included as JSONRPC2.Serializers.Jiffy, and legacy users can select Poison if they have included it as a dependency.To use a different serializer you must configure it in your Mix config. For the jiffy serializer:config :jsonrpc2, :serializer, JSONRPC2.Serializers.JiffyIf you are going to use the jiffy serializer, you must add it to your deps instead of jason:def deps do [..., {:jiffy, &quot;~&gt; 1.0&quot;}] endIf you use your own serializer, you do not (necessarily) need to add jason or jiffy to your deps.","ref":"readme.html#serialization","title":"JSONRPC2 - Serialization","type":"extras"},{"doc":"If you plan to use the TCP/TLS server, you also need to add ranch to your deps.def deps do [..., {:ranch, &quot;~&gt; 1.7&quot;}] end","ref":"readme.html#tcp-tls-server","title":"JSONRPC2 - TCP/TLS server","type":"extras"},{"doc":"If you plan to use the TCP/TLS client, you also need to add shackle to your deps/apps.def deps do [..., {:shackle, &quot;~&gt; 0.5&quot;}] end","ref":"readme.html#tcp-tls-client","title":"JSONRPC2 - TCP/TLS client","type":"extras"},{"doc":"If you plan to use the HTTP(S) server, you also need to add plug, cowboy, and plug_cowboy to your deps.def deps do [..., {:plug, &quot;~&gt; 1.8&quot;}, {:cowboy, &quot;~&gt; 2.6&quot;}, {:plug_cowboy, &quot;~&gt; 2.0&quot;}] end","ref":"readme.html#http-s-server","title":"JSONRPC2 - HTTP(S) server","type":"extras"},{"doc":"If you plan to use the HTTP(S) client, you also need to add hackney to your deps.def deps do [..., {:hackney, &quot;~&gt; 1.15&quot;}] end","ref":"readme.html#http-s-client","title":"JSONRPC2 - HTTP(S) client","type":"extras"}]